// ENTITY_IMD Class
// (c) by Heinrich Tillack 2002 (http://a128.x15.org)
// under GPL or new BSD license
//
// with IMD code taken from Iris3D V0.7
// Author : Olivier Chatry - Epitech Console Laboratory
//           (http://www.epitech.net/labconsole/)
// v 0 (21.10.02): initial release

#ifndef ENTITY_IMDH
#define ENTITY_IMDH


#include "model3d.h"
#include "object.h"

#include "imd.hpp"


class ENTITY_IMD : public OBJECT
{
public:


    ENTITY_IMD();
    ~ENTITY_IMD();


    GLvoid Load(char *file_name,char *file_path,float scale=1);

    GLvoid Draw();


private:

    t3DModel model;


    char								*_file_name;
    char								*_name; //name of entity model
    int								 _num_anim;

    void LoadMaterial(imd_object_t *imd_object, char *file_path);
    void LoadMesh(imd_object_t *imd_object,float scale=1);


};



#endif

