// (c) by Heinrich Tillack 2002 (http://a128.x15.org)
// based on code by Kamka and md2Viewer by Chalumbasoft?!
// under GPL or new BSD license
// v 0 (21.10.02): initial release
#ifndef MD2_H
#define MD2_H


struct pt {
    //point coords
    float x;
    float y;
    float z;
#ifdef MD2_LIGHT

    //normal to this point
    float nx;
    float ny;
    float nz;

    //shadelight normal?!!!from Q2 ql_mesh.c
    float l;

#endif
};

struct poly {
    struct pt point[8];
    unsigned int vert_count;
    unsigned int tex_id;
    struct poly *next;
};


/* from the original specs */
struct md2_model_hdr {
    int magic;
    int version;
    int skinWidth;
    int skinHeight;
    int frameSize;
    int numSkins;
    int numVertices;
    int numTexCoords;
    int numTriangles;
    int numGlCommands;
    int numFrames;
    int offsetSkins;
    int offsetTexCoords;
    int offsetTriangles;
    int offsetFrames;
    int offsetGlCommands;
    int offsetEnd;
};

struct md2_pt {
    unsigned char vertex[3]; //X, Y, Z
    unsigned char lightNormalIndex;
};

struct md2_frame_hdr {
    float scale[3];
    float translate[3];
    char name[16];

};

struct frame {
    char name[16];
    struct pt *points;
};

struct triangle {
    unsigned short vertex[3];
    unsigned short texture[3];
};

struct tex_coord {
    float s;
    float t;
};

struct md2_model_node {
    int trianglecount;
    int framecount;
    int verticount;
    struct frame *frames;
    struct tex_coord *texcoord;
    struct triangle *triangles;
    int		*glCommandBuffer;
    char frame_class[20];
    char *filename;
    //struct md2_model_node *next;
};


int find_frame(struct md2_model_node *model, char *name);
struct md2_model_node *load_md2(char *filename,float scale) ;

//free the model memory
void free_md2(struct md2_model_node *model);

struct md2_model_node *get_model();

/*draws a md2 model with GL_TRIANGLES commands */
void draw_md2(struct md2_model_node *model, int texid, float mx, float my, float mz, int frame1, int frame2, int blendpos, int blendcount) ;

/*draws a md2 model with GL commands (fan/stripes) */

void draw_gl_md2(struct md2_model_node *model, int texid, float mx, float my, float mz, float angle_y, int frame1, int frame2, int blendpos, int blendcount) ;

/* center model */
void getBoundingBox_md2 (struct md2_model_node *model, float *minmax);

float
getBoundingSphere_md2 (struct md2_model_node *model,float *cx,float *cy,float *cz);



#endif


